<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qtcreator-documentation.qdoc -->
  <title>Writing Documentation | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Writing Documentation</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="external-tool-spec.html" />
  <link rel="next" href="coding-style.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="external-tool-spec.html">External Tool Specification Files</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="coding-style.html">Qt Creator Coding Rules</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#configuring-the-documentation-project">Configuring the Documentation Project</a></li>
<li class="level2"><a href="#creating-folders-and-files">Creating Folders and Files</a></li>
<li class="level2"><a href="#integrating-topics-to-documentation">Integrating Topics to Documentation</a></li>
<li class="level2"><a href="#updating-next-and-previous-links">Updating Next and Previous Links</a></li>
<li class="level1"><a href="#writing-text">Writing Text</a></li>
<li class="level2"><a href="#capitalizing-headings">Capitalizing Headings</a></li>
<li class="level1"><a href="#using-images">Using Images</a></li>
<li class="level2"><a href="#taking-screen-shots">Taking Screen Shots</a></li>
<li class="level2"><a href="#hightlighting-parts-of-the-screen">Hightlighting Parts of the Screen</a></li>
<li class="level2"><a href="#optimizing-images">Optimizing Images</a></li>
<li class="level1"><a href="#building-documentation">Building Documentation</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Writing Documentation</h1>
<span class="subtitle"></span>
<!-- $$$qtcreator-documentation.html-description -->
<div class="descr"> <a name="details"></a>
<p>When you add plugins or contribute new features to Qt Creator, you probably want other people to know about them and to be able to use them. Therefore, you should also contribute documentation for them. Follow the guidelines in this section to make sure that your documentation fits in well with the rest of the Qt Creator documentation.</p>
<p>When you contribute a plugin, you should write documentation both for the developers who use Qt Creator and for the ones who develop it.</p>
<p>Write the following user documentation for addition to the Qt Creator Manual:</p>
<ul>
<li>Overview topic, which describes the purpose of your plugin from the viewpoint of Qt Creator users</li>
<li>Procedure topics, which describe how to use your plugin as part of Qt Creator</li>
<li>Reference topics, which contain information that developers occasionally need to look up (optional)</li>
</ul>
<p>Write the following developer documentation for addition to the Extending Qt Creator Manual:</p>
<ul>
<li>Overview topic, which describes the architecture and use cases for your plugin from the viewpoint of Qt Creator developers</li>
<li>API documentation, which is generated from code comments</li>
</ul>
<a name="configuring-the-documentation-project"></a>
<h2 id="configuring-the-documentation-project">Configuring the Documentation Project</h2>
<p>Qt Creator documentation is written by using QDoc. For more information about using QDoc, see the <a href="http://doc.qt.io/qt-5/qdoc-index.html">QDoc Manual</a>.</p>
<p>QDoc finds the new topics automatically, when you place them as <code>.qdoc</code> files in the correct folder. However, to make the topics accessible to readers, you must also add them to the table of contents (<code>doc\src\qtcreator-toc.qdoc</code>) and fix the next page and previous page links to them from other topics.</p>
<a name="creating-folders-and-files"></a>
<h3 id="creating-folders-and-files">Creating Folders and Files</h3>
<p>These instructions apply only to the Qt Creator Manual. Add API documentation directly to the code source files. However, you can write an API overview also as a separate <code>.qdoc</code> file.</p>
<p>Create a subfolder for your documentation in the Qt Creator project folder in the <code>doc\src</code> folder. Create a separate file for each topic.</p>
<p>The easiest way is probably to copy an existing file, save it as a new file, and modify it. This way, you already have samples of the necessary bits and pieces in place, such as topic start and end commands, copyright statement, links to next and previous topics, and topic title.</p>
<a name="integrating-topics-to-documentation"></a>
<h3 id="integrating-topics-to-documentation">Integrating Topics to Documentation</h3>
<p>You must integrate your new topics to the Qt Creator Manual and Extending Qt Creator Manual by adding links to them to the table of contents and to other relevant topics.</p>
<p>To link to the topic, you can use the topic title. For example:</p>
<pre class="cpp">

  \l{Integrating Topics to Documentation}

</pre>
<p>This does not work if topic titles are not unique. Also, if you change the title, the link breaks. You can avoid this risk by adding the <code>\target</code> command to your topic and then linking to the target.</p>
<a name="updating-next-and-previous-links"></a>
<h3 id="updating-next-and-previous-links">Updating Next and Previous Links</h3>
<p>When you add new topics to a document, you must also change the navigation links of the topics around them. This is very error prone when done manually, and therefore we have a script called <code>fixnavi.pl</code> for it. For the script to work, you must add the <code>\nextpage</code> and <code>\previouspage</code> commands to the topic, with dummy values (for example, <code>\nextpage=anything.html</code>).</p>
<p><b>Note: </b>The script creates the links according to the TOC in the topic set as the value of the <code>indexTitle</code> configuration parameter (<code>doc\src\qtcreator-toc.qdoc</code>). If your topics are not listed in the TOC, the script removes the <code>\nextpage</code> and <code>\previouspage</code> commands from them.</p><p>To run the script, you must have Perl installed. If you build Qt yourself, you should already have it. Otherwise, download and install <a href="http://www.perl.org/">Perl</a>.</p>
<p>To run the script, enter the following command in the doc folder:</p>
<ul>
<li>nmake fixnavi (on Windows)</li>
<li>make fixnavi (on Linux)</li>
</ul>
<a name="writing-text"></a>
<h2 id="writing-text">Writing Text</h2>
<p>Follow the guidelines for <a href="http://wiki.qt.io/Writing_Qt_Documentation">writing Qt documentation</a>.</p>
<p>The documentation must be grammatically correct English and use the standard form of written language. Do not use dialect or slang words. Use idiomatic language, that is, expressions that are characteristic for English. If possible, ask a native English speaker for a review.</p>
<a name="capitalizing-headings"></a>
<h3 id="capitalizing-headings">Capitalizing Headings</h3>
<p>Use the book title capitalization style for all titles and section headings (<code>\title</code>, <code>\section1</code>, <code>\section2</code>, and so on). For more information, see <a href="qtcreator-ui-text.html#using-book-style-capitalization">Using Book Style Capitalization</a>.</p>
<a name="using-images"></a>
<h2 id="using-images">Using Images</h2>
<p>You can illustrate your documentation by using screen shots, diagrams, and other images.</p>
<p>Use the <code>\image</code> and <code>\inlineimage</code> QDoc commands to refer to images from the text. You do not need to add paths to image names. For example:</p>
<pre class="cpp">

  \image riot<span class="operator">.</span>png

</pre>
<a name="taking-screen-shots"></a>
<h3 id="taking-screen-shots">Taking Screen Shots</h3>
<p>Qt Creator has the native look and feel on Windows, Linux, and <a href="http://doc.qt.io/qt-5/internationalization.html#macos">macOS</a>, and therefore, screen shots can end up looking very different, depending on who takes them and which system they use. To try to preserve a consistent look and feel in the Qt Creator Manual, observe the guidelines listed in this section when taking screen shots.</p>
<p><b>Note: </b>Do not rely on screen shots present reasonable example values to users, but always place example values also in the text.</p><ul>
<li>Use the screen resolution of 1366x768 (available on the most commonly used screens, as of this writing).</li>
<li>Use the aspect ratio of 16:9.</li>
<li>Open the application in the maximum size on full screen.</li>
<li>Use your favorite tool to take the screen shot.</li>
<li>Include only the part of the screen that you need (you can crop the image also in the screen capture tool).</li>
<li>To highlight parts of the screen shot, use the images of numbers that are stored in <code>doc\images\numbers</code> in the Qt Creator repository.</li>
<li>Before you submit the images to the repository, optimize them to save space.</li>
</ul>
<a name="hightlighting-parts-of-the-screen"></a>
<h3 id="hightlighting-parts-of-the-screen">Hightlighting Parts of the Screen</h3>
<p>You can use number icons in screenshots to highlight parts of the screenshot (instead of using red arrows or borders, or something similar). You can then refer to the numbers in text. For and example, see the <a href="http://doc.qt.io/qt-5/topics-app-development.html">Development Tools</a> topic in the Qt reference documentation.</p>
<p>This improves the consistency of the look and feel of Qt documentation, and eliminates the need to describe parts of the UI in the text, because you can just insert the number of the element you are referring to in brackets.</p>
<p>You can find a set of images that show the numbers from 1 to 10 in the <code>doc\images\numbers</code> directory (or in the <code>qtdoc</code> module sources in <code>doc\images\numbers</code>).</p>
<p>To use the numbers, copy-paste the number images on the screenshot to the places that you want to refer to from text.</p>
<a name="optimizing-images"></a>
<h3 id="optimizing-images">Optimizing Images</h3>
<p>Save images in the PNG format in the Qt Creator project folder in the <code>doc\images</code> folder. Binary images can easily add megabytes to the Git history. To keep the history as small as possible, the Git post-commit hooks remind you to try to keep image size below 50 kilobytes. To achieve this goal, crop images so that only relevant information is visible in them. Before committing images, optimize them by using an image optimization tool.</p>
<p>Optimization should not visibly reduce image quality. If it does, do not do it.</p>
<p>You can use a web service, such as <a href="https://tinypng.com">https://tinypng.com</a>, or an image optimization tool to shrink the images. For example, you can use the Radical Image Optimization Tool (RIOT) or OptiPNG on Windows, ImageOptim on <a href="http://doc.qt.io/qt-5/internationalization.html#macos">macOS</a>, or some other tool available on Linux.</p>
<p>With ImageOptim, you simply drag and drop the image files to the application. The following section describes the settings to use for RIOT.</p>
<a name="using-riot"></a>
<h4 id="using-riot">Using RIOT</h4>
<p>Download and install <a href="http://luci.criosweb.ro/riot/">RIOT</a>.</p>
<p class="centerAlign"><img src="images/riot.png" alt="" /></p><p>Open your images in RIOT and use the following settings for them:</p>
<ul>
<li>Color reduction: Optimal 256 colors palette</li>
<li>Reduce colors to: 256</li>
<li>Best compression (slow)</li>
<li>Color quantization algorithm: NeuQuant neural-net (slow)</li>
<li>External optimizers: OptiPNG o3</li>
</ul>
<p>Compare the initial and optimized images to check that image quality is preserved. If the image quality deteriorates, do not use color reduction (select the <b>True Color</b> option, instead).</p>
<p>You can also see the sizes of the initial and optimized image.</p>
<a name="using-optipng"></a>
<h4 id="using-optipng">Using OptiPNG</h4>
<p>Download and install <a href="https://sourceforge.net/projects/optipng/">OptiPNG</a>.</p>
<p>OptiPNG is a command-line tool that you can invoke from the Qt Creator project folder (or any folder that contains your project). To optimize a screenshot, enter the following command (here, from the Qt Creator project folder):</p>
<pre class="cpp">

  optipng <span class="operator">-</span>o <span class="number">7</span> <span class="operator">-</span>strip all doc<span class="operator">/</span>images<span class="operator">/</span><span class="operator">&lt;</span>screenshot_name<span class="operator">&gt;</span>

</pre>
<a name="building-documentation"></a>
<h2 id="building-documentation">Building Documentation</h2>
<p>You use QDoc to build the documentation. Build the documentation from time to time, to check its structure and the validity of the QDoc commands. The error messages that QDoc issues are generally very useful for troubleshooting.</p>
<p>For more information about setting up the build environment if you do not want to build the whole Qt, see <a href="https://wiki.qt.io/Building_Qt_Documentation">Building Qt Documentation</a> on the Qt wiki.</p>
<p>The content and formatting of documentation are separated in QDoc. The documentation configuration, style sheets, and templates have changed over time, so they differ between Qt and Qt Creator versions. Since Qt Creator version 3.3, only Qt 5 is supported for building documentation. The templates to use are defined by the <code>qt5\qtbase\doc\global\qt-html-templates-offline.qdocconf</code> and <code>qt5\qtbase\doc\global\qt-html-templates-online.qdocconf</code> configuration file. They are fetched from Qt sources by adding the following lines to the qdocconf file:</p>
<ul>
<li><code>include ($QT_INSTALL_DOCS/global/qt-html-templates-offline.qdocconf)</code> for help files</li>
<li><code>include ($QT_INSTALL_DOCS/global/qt-html-templates-online.qdocconf)</code> for publishing on the web</li>
</ul>
<p><b>Note: </b>To have the correct fonts loaded for the online version, you must be running it on a web server.</p><p><b>Note: </b>If the styles look wrong to you when reading help files in Qt Creator or Qt Assistant, you might be looking at them in the <a href="http://doc.qt.io/qt-5/qtextbrowser.html">QTextBrowser</a> instead of the Qr WebEngine browser. This happens if you do not have Qt WebEngine installed.</p><p>To build documentation for the sources from the qtcreator master branch, use build scripts defined in the doc.pri file. To build all Qt Creator docs in the help format and to create help files (.qch), enter the following build commands from the project folder (after running qmake):</p>
<ul>
<li>nmake docs (on Windows)</li>
<li>make docs (on Linux and <a href="http://doc.qt.io/qt-5/internationalization.html#macos">macOS</a>)</li>
</ul>
<p>The Qt Creator Manual HTML files are generated in the <code>doc/qtcreator</code> directory. The Extending Qt Creator Manual files are generated in the <code>doc/qtcreator-dev</code> directory. The help files (<code>.qch</code>) are generated in the <code>share/doc/qtcreator</code> directory in the Qt Creator build directory on Windows and Linux, and in the <code>bin/Qt Creator.app/Contents/Resources/app</code> directory on <a href="http://doc.qt.io/qt-5/internationalization.html#macos">macOS</a>. You can view the HTML files in a browser and the help files in the Qt Creator <b>Help</b> mode. For more information about adding the help files to Qt Creator, see <a href="http://doc.qt.io/qtcreator/creator-help.html#adding-external-documentation">Adding External Documentation</a>.</p>
<p>Besides <code>docs</code>, you have the following options:</p>
<ul>
<li>html_docs_qtcreator - build Qt Creator Manual in help format, but do not generate a help file</li>
<li>html_docs_qtcreator-dev - build Extending Qt Creator Manual in help format, but do not generate a help file</li>
<li>qch_docs_qtcreator - build Qt Creator Manual in help format and generate a help file (.qch)</li>
<li>qch_docs_qtcreator-dev - build Extending Qt Creator Manual in help format and generate a help file (.qch)</li>
</ul>
</div>
<!-- @@@qtcreator-documentation.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="external-tool-spec.html">External Tool Specification Files</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="coding-style.html">Qt Creator Coding Rules</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
